#include <stdio.h>

#include <X11/Xlib.h>
#include <xview/xview.h>
#include <xview/notice.h>

#include "generic.h"

void tnotice_no_choice(p, x, y, s)
void *p;
int x, y;
char *s;
{
    (void) notice_prompt(titem_xview_window(p), NULL,
		NOTICE_MESSAGE_STRINGS, s, NULL,
		NOTICE_FOCUS_XY, x, y,
		NOTICE_BUTTON_NO, "Ok",
		NULL);
}

void tnotice_no_choice_2line(p, x, y, s1, s2)
void *p;
int x, y;
char *s1, *s2;
{
    (void) notice_prompt(titem_xview_window(p), NULL,
		NOTICE_MESSAGE_STRINGS, s1, s2, NULL,
		NOTICE_FOCUS_XY, x, y,
		NOTICE_BUTTON_NO, "Ok",
		NULL);
}

int tnotice_yes_no(p, x, y, s, yes, no)
void *p;
int x, y;
char *s;
char *yes, *no;
{
    int result;

    result = notice_prompt(titem_xview_window(p), NULL,
		NOTICE_MESSAGE_STRINGS, s, NULL,
		NOTICE_FOCUS_XY, x, y,
		NOTICE_BUTTON_YES, yes,
		NOTICE_BUTTON_NO, no,
		NULL);
    if(result==NOTICE_YES)
		return(1);
    else if(result==NOTICE_NO)
		return(0);
    else
		return(-1);
}

int tnotice_2line_2answer(p, x, y, s1, s2, a1, a2)
void *p;
int x, y;
char *s1, *s2;
char *a1, *a2;
{
    int result;

    result = notice_prompt(titem_xview_window(p), NULL,
		NOTICE_MESSAGE_STRINGS,
			s1, s2,
			NULL,
		NOTICE_FOCUS_XY, x, y,
		NOTICE_BUTTON, a1, 101,
		NOTICE_BUTTON, a2, 102,
		NULL);
    if(result==101)
		return(1);
    else if(result==102)
		return(2);
    else
		return(-1);
}

int tnotice_3line_3answer(p, x, y, s1, s2, s3, a1, a2, a3)
void *p;
int x, y;
char *s1, *s2, *s3;
char *a1, *a2, *a3;
{
    int result;

    result = notice_prompt(titem_xview_window(p), NULL,
		NOTICE_MESSAGE_STRINGS,
			s1, s2, s3,
			NULL,
		NOTICE_FOCUS_XY, x, y,
		NOTICE_BUTTON, a1, 101,
		NOTICE_BUTTON, a2, 102,
		NOTICE_BUTTON, a3, 103,
		NULL);
    if(result==101)
		return(1);
    else if(result==102)
		return(2);
    else if(result==103)
		return(3);
    else
		return(-1);
}
