#include <stdio.h>

/* fill.c:
 *
 * fills in the global structures that hold strings for the names of many
 * constants used in the program.
 *
 * Much of this was only used for debugging, however, it was a valuable
 * tool, and was kept in case it was needed later.
 */

#include "interface.h"

#include "treedata.h"

fill_in_strings()
{

	globals->treetool_error_strings[Message]="Message";
	globals->treetool_error_strings[BeepMessage]="BeepMessage";
	globals->treetool_error_strings[Notice]="Notice";
	globals->treetool_error_strings[OutOfMemory]="OutOfMemory";
	globals->treetool_error_strings[NoError]="NoError";

	globals->command_strings[Load]="Load";
	globals->command_strings[Save]="Save";
	globals->command_strings[Print]="Print";
	globals->command_strings[Quit]="Quit";
	globals->command_strings[GoEditFormat]="GoEditFormat";
	globals->command_strings[GoEditStructure]="GoEditStructure";
	globals->command_strings[GoEditTree]="GoEditTree";
	globals->command_strings[GoEditText]="GoEditText";
	globals->command_strings[GoEditMove]="GoEditMove";
	globals->command_strings[GoEditFlip]="GoEditFlip";
	globals->command_strings[GoEditHide]="GoEditHide";
	globals->command_strings[Undo]="Undo";
	globals->command_strings[Cut]="Cut";
	globals->command_strings[Copy]="Copy";
	globals->command_strings[Paste]="Paste";
	globals->command_strings[PasteSubtree]="PasteSubtree";
	globals->command_strings[MoveOnscreen]="MoveOnscreen";
	globals->command_strings[MoveAllOnscreen]="MoveAllOnscreen";
	globals->command_strings[Select]="Select";
	globals->command_strings[AddToSelection]="AddToSelection";
	globals->command_strings[AddNodeListToSelection]="AddNodeListToSelection";
	globals->command_strings[ToggleSelection]="ToggleSelection";
	globals->command_strings[RemoveFromSelection]="RemoveFromSelection";
	globals->command_strings[ConnectSelections]="ConnectSelections";
	globals->command_strings[SelectAll]="SelectAll";
	globals->command_strings[PruneToReps]="PruneToReps";
	globals->command_strings[MergeMergeableNodes]="MergeMergeableNodes";
	globals->command_strings[MoveCarat]="MoveCarat";
	globals->command_strings[MoveToParent]="MoveToParent";
	globals->command_strings[MoveToLeftChild]="MoveToLeftChild";
	globals->command_strings[MoveToRightChild]="MoveToRightChild";
	globals->command_strings[MoveToLeftSister]="MoveToLeftSister";
	globals->command_strings[MoveToRightSister]="MoveToRightSister";
	globals->command_strings[MoveBranchSelectionUp]="MoveBranchSelectionUp";
	globals->command_strings[MoveBranchSelectionDown]="MoveBranchSelectionDown";
	globals->command_strings[HideLevel]="HideLevel";
	globals->command_strings[ShowLevel]="ShowLevel";
	globals->command_strings[HideNode]="HideNode";
	globals->command_strings[ShowNode]="ShowNode";
	globals->command_strings[ShowHandles]="ShowHandles";
	globals->command_strings[HideHandles]="HideHandles";
	globals->command_strings[ShowPageLines]="ShowPageLines";
	globals->command_strings[HidePageLines]="HidePageLines";
	globals->command_strings[ShowTextBoxes]="ShowTextBoxes";
	globals->command_strings[HideTextBoxes]="HideTextBoxes";
	globals->command_strings[AutoformatOn]="AutoformatOn";
	globals->command_strings[AutoformatOff]="AutoformatOff";
	globals->command_strings[SetTreeFormat]="SetTreeFormat";
	globals->command_strings[GetTreeFormat]="GetTreeFormat";
	globals->command_strings[SetTreeBranchFormat]="SetTreeBranchFormat";
	globals->command_strings[ShowInternalNames]="ShowInternalNames";
	globals->command_strings[HideInternalNames]="HideInternalNames";
	globals->command_strings[ShowTerminalNames]="ShowTerminalNames";
	globals->command_strings[HideTerminalNames]="HideTerminalNames";
	globals->command_strings[ShowScaleBar]="ShowScaleBar";
	globals->command_strings[HideScaleBar]="HideScaleBar";
	globals->command_strings[TranslateNames]="TranslateNames";
	globals->command_strings[EvenSpacing]="EvenSpacing";
	globals->command_strings[ChangeOutgroup]="ChangeOutgroup";
	globals->command_strings[SetScale]="SetScale";
	globals->command_strings[GetScale]="GetScale";
	globals->command_strings[SetScaleBarPosition]="SetScaleBarPosition";
	globals->command_strings[SetScaleBarValue]="SetScaleBarValue";
	globals->command_strings[GetScaleBarValue]="GetScaleBarValue";
	globals->command_strings[SetScaleBarFont]="SetScaleBarFont";
	globals->command_strings[GetScaleBarFont]="GetScaleBarFont";
	globals->command_strings[SetScaleBarColor]="SetScaleBarColor";
	globals->command_strings[GetScaleBarColor]="GetScaleBarColor";
	globals->command_strings[MoveTree]="MoveTree";
	globals->command_strings[ResizeTree]="ResizeTree";
	globals->command_strings[SetFontAllTrees]="SetFontAllTrees";
	globals->command_strings[MoveNode]="MoveNode";
	globals->command_strings[RotateNode]="RotateNode";
	globals->command_strings[GetNodeName]="GetNodeName";
	globals->command_strings[SetNodeName]="SetNodeName";
	globals->command_strings[GetNodePosition]="GetNodePosition";
	globals->command_strings[SetNodePosition]="SetNodePosition";
	globals->command_strings[GetNodeLabelPosition]="GetNodeLabelPosition";
	globals->command_strings[SetNodeLabelPosition]="SetNodeLabelPosition";
	globals->command_strings[FlipNode]="FlipNode";
	globals->command_strings[SetNodeFont]="SetNodeFont";
	globals->command_strings[GetNodeFont]="GetNodeFont";
	globals->command_strings[FixLabel]="FixLabel";
	globals->command_strings[SetNodeColor]="SetNodeColor";
	globals->command_strings[GetNodeColor]="GetNodeColor";
	globals->command_strings[MoveNodeLabel]="MoveNodeLabel";
	globals->command_strings[SetThickness]="SetThickness";
	globals->command_strings[GetThickness]="GetThickness";
	globals->command_strings[SetBranchColor]="SetBranchColor";
	globals->command_strings[GetBranchColor]="GetBranchColor";
	globals->command_strings[EveryNodeAndSubtree]="EveryNodeAndSubtree";
	globals->command_strings[EveryNode]="EveryNode";
	globals->command_strings[EveryTree]="EveryTree";
	globals->command_strings[EveryBranch]="EveryBranch";
	globals->command_strings[NoCommand]="NoCommand";

	globals->tree_type_strings[Flower]="Radial Tree";
	globals->tree_type_strings[Boxed]="Phenogram";
	globals->tree_type_strings[NoTreeType]="NoTreeType";

	globals->branch_type_strings[Midway]="Midway";
	globals->branch_type_strings[RoomForGroup]="RoomForGroup";
	globals->branch_type_strings[OnScreen]="OnScreen";
	globals->branch_type_strings[FlowerBranch]="FlowerBranch";
	globals->branch_type_strings[NoBranchType]="NoBranchType";

	globals->name_type_strings[NormalNames]="NormalNames";
	globals->name_type_strings[FullNames]="FullNames";
	globals->name_type_strings[ShortNames]="ShortNames";
	globals->name_type_strings[AbbreviatedNames]="AbbreviatedNames";
	globals->name_type_strings[NoNameType]="NoNameType";

	globals->selection_type_strings[MultiSel]="MultiSel";
	globals->selection_type_strings[NodeSel]="NodeSel";
	globals->selection_type_strings[BranchPointSel]="BranchPointSel";
	globals->selection_type_strings[SubtreeSel]="SubtreeSel";
	globals->selection_type_strings[NodeSubtreeSel]="NodeSubtreeSel";
	globals->selection_type_strings[TextSel]="TextSel";
	globals->selection_type_strings[TreeSel]="TreeSel";
	globals->selection_type_strings[NoSel]="NoSel";

	globals->caret_movement_strings[CaretBack]="CaretBack";
	globals->caret_movement_strings[CaretForward]="CaretForward";
	globals->caret_movement_strings[CaretStart]="CaretStart";
	globals->caret_movement_strings[CaretEnd]="CaretEnd";
	globals->caret_movement_strings[CaretNoMove]="CaretNoMove";

	globals->file_type_strings[Treetool]="Treetool";
	globals->file_type_strings[Newick]="Newick";
	globals->file_type_strings[Prolog]="Prolog";
	globals->file_type_strings[PostScript]="PostScript";
	globals->file_type_strings[PICT]="PICT";
	globals->file_type_strings[List]="List";
	globals->file_type_strings[NoFileType]="NoFileType";

	globals->mouse_mode_strings[MouseTree]="MouseTree";
	globals->mouse_mode_strings[MouseText]="MouseText";
	globals->mouse_mode_strings[MouseFlip]="MouseFlip";
	globals->mouse_mode_strings[MouseReRoot]="MouseReRoot";
	globals->mouse_mode_strings[MouseMove]="MouseMove";
	globals->mouse_mode_strings[MouseHide]="MouseHide";
	globals->mouse_mode_strings[MouseNoMode]="MouseNoMode";
}
